LC 486. Predict the Winner

Given an array of scores that are non-negative integers. Player 1 picks one of the numbers from either end of the array followed by the player 2 and then player 1 and so on. Each time a player picks a number, that number will not be available for the next player. This continues until all the scores have been chosen. The player with the maximum score wins.

Given an array of scores, predict whether player 1 is the winner. You can assume each player plays to maximize his score.

Example 1:

Input: [1, 5, 2]
Output: False
Explanation: Initially, player 1 can choose between 1 and 2. If he chooses 2 (or 1), then player 2 can choose from 1 (or 2) and 5. If player 2 chooses 5, then player 1 will be left with 1 (or 2). So, final score of player 1 is 1 + 2 = 3, and player 2 is 5. Hence, player 1 will never be the winner and you need to return False.

Example 2:

Input: [1, 5, 233, 7]
Output: True
Explanation: Player 1 first chooses 1. Then player 2 have to choose between 5 and 7. No matter which number player 2 choose, player 1 can choose 233.Finally, player 1 has more score (234) than player 2 (12), so you need to return True representing player1 can win.

Note:

  1. 1 <= length of the array <= 20.
  2. Any scores in the given array are non-negative integers and will not exceed 10,000,000.
  3. If the scores of both players are equal, then player 1 is still the winner.

Runtime: 8 ms, faster than 19.93% of C++ online submissions for Predict the Winner.

Memory Usage: 5.1 MB, less than 0.75% of C++ online submissions for Predict the Winner.

class Solution {
public:
  bool PredictTheWinner(vector<int>& nums) {
    int N = nums.size();

    vector<vector<int>> mtx(N+1, vector<int>(N+1, 0));

    for(int gap = 0; gap < nums.size(); gap++) {
      for(int i=1; i<nums.size()+1; i++) {
        for(int j=i; j <= i+gap && j <= N; j++) {
          if(j == i) mtx[i][j] = nums[i-1];
          else if(j == i+1) {
            mtx[i][j] = max(nums[i-1], nums[j-1]);
            mtx[j][i] = min(nums[i-1], nums[j-1]);
          }
          else {
            int takeleft = mtx[j][i+1] + nums[i-1];
            int takeright = mtx[j-1][i] + nums[j-1];
            mtx[i][j] = max(takeleft, takeright);
            if(takeleft > takeright) mtx[j][i] = mtx[i+1][j];
            else if(takeleft < takeright) mtx[j][i] = mtx[i][j-1];
            else mtx[j][i] = min(mtx[i+1][j], mtx[i][j-1]);
          }
        }
      }
    }
    bool canwin = mtx[1][N] >= mtx[N][1];
    return canwin;
  }
};

原文地址:https://www.cnblogs.com/ethanhong/p/10354419.html

时间: 2024-10-11 19:02:34

LC 486. Predict the Winner的相关文章

LN : leetcode 486 Predict the Winner

lc 486 Predict the Winner 486 Predict the Winner Given an array of scores that are non-negative integers. Player 1 picks one of the numbers from either end of the array followed by the player 2 and then player 1 and so on. Each time a player picks a

486. Predict the Winner

Given an array of scores that are non-negative integers. Player 1 picks one of the numbers from either end of the array followed by the player 2 and then player 1 and so on. Each time a player picks a number, that number will not be available for the

随手练——博弈论入门 leetcode - 486. Predict the Winner

题目链接:https://leetcode.com/problems/predict-the-winner/ 1.暴力递归 当前数组左边界:i,右边界:j: 对于先发者来说,他能取到的最大值是:max(arr[i] + second(arr, i + 1, j), arr[j] + second(arr, i, j - 1)); (arr[i] + 作为后发者,在 i+1 到 j 上取得的值),(arr[j] + 作为后发者,在 i 到 j-1 上取得的值) 中大的一个. 对于后发者来说,他是被

[LeetCode] Predict the Winner 预测赢家

Given an array of scores that are non-negative integers. Player 1 picks one of the numbers from either end of the array followed by the player 2 and then player 1 and so on. Each time a player picks a number, that number will not be available for the

[Leetcode] DP-- 486. Predict the Winner

Given an array of scores that are non-negative integers. Player 1 picks one of the numbers from either end of the array followed by the player 2 and then player 1 and so on. Each time a player picks a number, that number will not be available for the

leetcode486 Predict the Winner

思路: 博弈. 实现: 1 class Solution 2 { 3 public: 4 5 bool PredictTheWinner(vector<int>& nums) 6 { 7 int dp[21][21]; 8 int n = nums.size(); 9 for (int i = 0; i < n; i++) dp[i][i] = nums[i]; 10 for (int i = n - 1; i >= 0; i--) 11 { 12 for (int j =

过中等难度题目.0310

  .   8  String to Integer (atoi)    13.9% Medium   . 151 Reverse Words in a String      15.7% Medium     . 288 Unique Word Abbreviation      15.8% Medium     . 29 Divide Two Integers      16.0% Medium     . 166 Fraction to Recurring Decimal      17.

继续过中等难度.0309

  .   8  String to Integer (atoi)    13.9% Medium   . 151 Reverse Words in a String      15.7% Medium     . 288 Unique Word Abbreviation      15.8% Medium     . 29 Divide Two Integers      16.0% Medium     . 166 Fraction to Recurring Decimal      17.

LeetCode Problems List 题目汇总

No. Title Level Rate 1 Two Sum Medium 17.70% 2 Add Two Numbers Medium 21.10% 3 Longest Substring Without Repeating Characters Medium 20.60% 4 Median of Two Sorted Arrays Hard 17.40% 5 Longest Palindromic Substring Medium 20.70% 6 ZigZag Conversion Ea